/**
 * @file Power.h
 * @author Phillip Kühne
 * @brief This component provides utilities for keeping track of power usage
 * consumption.
 * @version 0.1
 * @date 2024-11-23 
 */

#include "Power.h"

Power::Power()
{
    this->free_power_budget = this->total_power_budget;
}

bool Power::tryAccquirePowerAllowance(uint16_t neededPower)
{
    if (this->free_power_budget >= neededPower)
    {
        this->free_power_budget -= neededPower;
        return true;
    }
    else
    {
        return false;
    }
}

void Power::releasePower(uint16_t power)
{
    if (this->free_power_budget + power <= this->total_power_budget)
    {
        this->free_power_budget += power;
    }
    else // TODO: Maybe we should actually throw an error here, since obviouslsy someone used us wrong.
    {
        this->free_power_budget = this->total_power_budget;
    }
}
